12345678910111213141516171819202122232425262728293031323334353637383940414243444546474849505152535455565758596061626364656667686970717273747576777879808182838485868788899091929394959697989910010110210310410510610710810911011111211311411511611711811912012112212312412512612712812913013113213313413513613713813914014114214314414514614714814915015115215315415515615715815916016116216316416516616716816917017117217317417517617717817918018118218318418518618718818919019119219319419519619719819920020120220320420520620720820921021121221321421521621721821922022122222322422522622722822923023123223323423523623723823924024124224324424524624724824925025125225325425525625725825926026126226326426526626726826927027127227327427527627727827928028128228328428528628728828929029129229329429529629729829930030130230330430530630730830931031131231331431531631731831932032132232332432532632732832933033133233333433533633733833934034134234334434534634734834935035135235335435535635735835936036136236336436536636736836937037137237337437537637737837938038138238338438538638738838939039139239339439539639739839940040140240340440540640740840941041141241341441541641741841942042142242342442542642742842943043143243343443543643743843944044144244344444544644744844945045145245345445545645745845946046146246346446546646746846947047147247347447547647747847948048148248348448548648748848949049149249349449549649749849950050150250350450550650750850951051151251351451551651751851952052152252352452552652752852953053153253353453553653753853954054154254354454554654754854955055155255355455555655755855956056156256356456556656756856957057157257357457557657757857958058158258358458558658758858959059159259359459559659759859960060160260360460560660760860961061161261361461561661761861962062162262362462562662762862963063163263363463563663763863964064164264364464564664764864965065165265365465565665765865966066166266366466566666766866967067167267367467567667767867968068168268368468568668768868969069169269369469569669769869970070170270370470570670770870971071171271371471571671771871972072172272372472572672772872973073173273373473573673773873974074174274374474574674774874975075175275375475575675775875976076176276376476576676776876977077177277377477577677777877978078178278378478578678778878979079179279379479579679779879980080180280380480580680780880981081181281381481581681781881982082182282382482582682782882983083183283383483583683783883984084184284384484584684784884985085185285385485585685785885986086186286386486586686786886987087187287387487587687787887988088188288388488588688788888989089189289389489589689789889990090190290390490590690790890991091191291391491591691791891992092192292392492592692792892993093193293393493593693793893994094194294394494594694794894995095195295395495595695795895996096196296396496596696796896997097197297397497597697797897998098198298398498598698798898999099199299399499599699799899910001001100210031004100510061007100810091010101110121013101410151016101710181019102010211022102310241025102610271028102910301031103210331034103510361037103810391040104110421043104410451046 |
- #!/bin/bash
- # -*- coding: utf-8-unix -*-
- TEXTDOMAIN=vbootstrap
- TEXTDOMAINDIR=/usr/share/locale
- Usage(){
- cat<<EOF
- $(basename $0) @@VBUILDER_VERSION@@ $(echo $([ -z "@@VBUILDER_REVISION@@" ] || echo "(r@@VBUILDER_REVISION@@)"))
- Usage: $(basename $0) {--profile [profile]} {--version [version]} {--arch [arch]} {--category [categories]} {--fetch-url [fetch_url]} {--dist-upgrade} {--target [target]} {--no-build-essential} {--with-compat32} {--rpmbuild-define [macro_expr]} {--rpmbuild-with [bcond_with]} {--rpmbuild-without [bcond_with]} {--sign} {--no-install} {--debug} {--help} {--bootstrap-dir [directory]} {--unionfs-dir [directory]} {--cache-dir [directory]} {--built-rpms-dir [directory]} {clean|build|build-rpm [src.rpm]|install-rpm [arch.rpm|package]|remove-rpm [package]}
- EOF
- echo $"
- Options:
- --profile: set a profile
- --version: set [version] (default: ${VERSION})
- --arch: set [arch] (default: ${UARCH})
- --category: set [categories] (default: ${CATEGORIES})
- --fetch-url: set [fetch_url] to fetch packages (default: ${VBOOTSTRAP_FETCH_URL})
- --dist-upgrade: make VineSeed bootstrap via ${STABLE_VERSION}
- --unionfs: cover a bootstrap with unionfs
- --target: build rpms with [target]
- --no-build-essential: do not install build-essential
- --with-compat32: build rpms with compat32 on bootstrap
- --rpmbuild-define: give a option --define [macro_expr] to rpmbuild
- --rpmbuild-with: give a option --with [bcond_with] to rpmbuild
- --rpmbuild-without: give a option --without [bcond_with] to rpmbuild
- --sign: sign built rpms
- --no-install: build only a source rpm - do NOT install a built rpm
- --login: login in chroot as root user
- --bootstrap-dir: set a bootstrap directory (default: ${VBOOTSTRAP_DIR})
- --unionfs-dir: set a directory to store unionfs images of vbootstrap (default: ${UNIONFS_DIR})
- --cache-dir: set a directory to cache rpms (default: ${CACHE_DIR})
- --built-rpms-dir: set a directory to store built rpms in chroot (default: ${BUILT_RPMS_DIR})
- --debug: enable debug mode
- --help: show this help
- "
- echo $"
- Actions:
- clean: clean the bootstrap of [version]
- build: build a bootstrap of [version]
- build-rpm: build [src.rpm] on a bootstrap
- install-rpm: install [arch.rpm|package] on a bootstrap
- remove-rpm: remove [package] on a bootstrap
- "
- echo $"
- Examples:
- * make a clean/plain build environment on the current archtecture:
- $(basename $0) clean build
- * build rpms from the specified source rpm:
- $(basename $0) build-rpm [src.rpm]
- * make a plain build environment for Vine Linux 6:
- $(basename $0) --version 6 clean build
- * make a i386 chroot on x86_64:
- $(basename $0) --arch i386 clean build
- * build a kernel package with target i686:
- $(basename $0) --target i686 build-rpm [kernel src.rpm]
- * build a compat32 package:
- $(basename $0) --arch i386 --with-compat32 build-rpm [src.rpm]
- "
- /usr/sbin/vbootstrap | sed -e s/^Usage:.*// -e s/^E:.*//
- ## TODO: output supported profiles and their names/comments
- }
- ##############################################################################
- initialize-variables(){
- ## set boolian variables
- with_profile=0
- with_setup_vbootstrap=0
- with_dist_upgrade=0
- with_unionfs=0
- with_sign=0
- with_no_install=0
- with_login=0
- with_debug=0
- with_actions=0
- with_ix86_on_x86_64=0
- with_category_main=0
- with_category_plus=0
- with_category_nonfree=0
- with_category_test=0
- with_category_proposed_updates=0
- with_category_security=0
- with_build_essential=1
- return 0
- }
- check-parameter(){
- [ -z "$*" ] && Usage && return 1
- while [ ! -z "$*" ]; do
- case $1 in
- --help|help)
- setup-vbuilder ||:
- Usage
- return 1
- ;;
- --profile)
- shift
- with_profile=1
- PROFILE=$1
- check-next-parameter $1 || return 1
- ;;
- --version|--arch|--category|--fetch-url|--target|--rpmbuild-define|--rpmbuild-with|--rpmbuild-without|--bootstrap-dir|--unionfs-dir|--cache-dir|--built-rpms-dir)
- [ $with_actions -eq 1 ] && \
- echo $"E: You can give no more options after actions" && \
- return 1
- shift
- check-next-parameter $1 || return 1
- ;;
- --dist-upgrade|--unionfs|--with-compat32|--sign|--no-install|--login|--no-build-essential|--debug)
- [ $with_actions -eq 1 ] && \
- echo $"E: You can give no more options after actions" && \
- return 1
- ;;
- --build-rpm|build-rpm|--install-rpm|install-rpm|--remove-rpm|remove-rpm)
- with_actions=1
- shift
- check-next-parameter $1 || return 1
- ;;
- --build|build|--clean|clean)
- with_actions=1
- ;;
- *)
- echo $"E: Missing some parameters after $1"
- return 1
- ;;
- esac
- shift
- done
- [ $with_actions -eq 0 ] && \
- echo $"E: You must give at least one action" && return 1
- return 0
- }
- check-next-parameter(){
- [ -z "$1" ] && echo $"E: Missing some parameters after $1" && return 1
- [ $(echo $1 | grep '^-') ] && \
- echo $"E: Missing some parameters after $1" && return 1
- return 0
- }
- ## NOTE: setup-vbuilder() loads
- ## - system wide configurations (from /etc/vbootstrap/vbuilder.conf)
- ## - given profile (from /etc/vbootstrap/profile.d/*.conf)
- ## - given command-line parameters
- ## where given command-line parameters override the settings given profile,
- ## and the settings given profile override system wide settings.
- ## If you use a profile of vbuilder, you may not override the settings
- ## given profile.
- setup-vbuilder(){
- ## check $SUDO_USER and $USERHELPER_UID
- RPM_SIGN_USER=$SUDO_USER
- if [ -z "${RPM_SIGN_USER}" ]; then
- [ -z "${USERHELPER_UID}" ] && \
- echo $"W: \$SUDO_USER and \$USERHELPER_UID are empty" && \
- return 1
-
- RPM_SIGN_USER=$(getent passwd $USERHELPER_UID | cut -d":" -f1)
- fi
- ## get $RPM_SIGN_USER's home directory
- HOME=$(getent passwd $RPM_SIGN_USER | cut -d":" -f6)
- ## load default settings
- VBUILDER_CONF=/etc/vbootstrap/vbuilder.conf
- if [ -r $VBUILDER_CONF ]; then
- . $VBUILDER_CONF
- [ $? -eq 1 ] && return 1
- fi
- [ -z "${CATEGORIES}" ] && \
- CATEGORIES=@@VBUILDER_CATEGORIES@@
- [ -z "${VBOOTSTRAP_FETCH_URL}" ] && \
- VBOOTSTRAP_FETCH_URL=@@VBUILDER_VBOOTSTRAP_FETCH_URL@@
- [ -z "${VBOOTSTRAP_DIR}" ] && \
- VBOOTSTRAP_DIR=@@VBUILDER_VBOOTSTRAP_DIR@@
- [ -z "${UNIONFS_DIR}" ] && \
- UNIONFS_DIR=@@VBUILDER_UNIONFS_DIR@@
- [ -z "${CACHE_DIR}" ] && \
- CACHE_DIR=@@VBUILDER_CACHE_DIR@@
- [ -z "${BUILT_RPMS_DIR}" ] && \
- BUILT_RPMS_DIR=@@VBUILDER_BUILT_RPMS_DIR@@
- ## set default version for vbootstrap
- VERSION=@@VBUILDER_DEFAULT_VERSION@@
- ## load profile
- if [ ${with_profile} -eq 1 ]; then
- [ ! -r /etc/vbootstrap/profile.d/${PROFILE}.conf ] && \
- echo $"E: No such profile found: ${PROFILE}" && return 1
- . /etc/vbootstrap/profile.d/${PROFILE}.conf
- [ $? -eq 1 ] && return 1
- fi
- ## set current stable relase version
- STABLE_VERSION=@@VBUILDER_STABLE_VERSION@@
- ## set default chroot archtecture
- UARCH=$(uname -i)
- case "${UARCH}" in
- arm*)
- UARCH="arm"
- ;;
- esac
- return 0
- }
- setup-vbootstrap(){
- if [ ${with_setup_vbootstrap} -eq 0 ]; then
- with_setup_vbootstrap=1
- ## check debug mode
- [ ${with_debug} -eq 1 ] && \
- cat $VBUILDER_CONF && \
- set && set -x
- ## check some directories
- ## Note: create $BUILT_RPMS_DIR in RPM_Build()
- [ -d $VBOOTSTRAP_DIR ] || mkdir -p $VBOOTSTRAP_DIR
- [ -d $CACHE_DIR ] || mkdir -p $CACHE_DIR
- ## check chroot version
- case ${VERSION} in
- 4.2|5.2|6|6.5|VineSeed)
- ;;
- 6.?)
- VERSION="6"
- ;;
- *)
- echo $"E: ${VERSION} is NOT supported"
- return 1
- ;;
- esac
- case "${VARCH}" in
- arm*)
- VARCH="arm"
- ;;
- esac
- ## check a chroot archtecture
- if [ -z ${VARCH} ]; then
- VARCH=${UARCH}
- else
- case "${VARCH}" in
- i386|x86_64)
- [ "${UARCH}" = "ppc" -o "${UARCH}" = "arm" ] && \
- echo $"E: arch ${VARCH} is NOT supported on ${UARCH}" && return 1
- ;;
- ppc)
- [ "${UARCH}" = "i386" -o "${UARCH}" = "x86_64" -o "${UARCH}" = "arm" ] && \
- echo $"E: arch ${VARCH} is NOT supported on ${UARCH}" && return 1
- ;;
- arm)
- [ "${UARCH}" = "i386" -o "${UARCH}" = "x86_64" -o "${UARCH}" = "ppc" ] && \
- echo $"E: arch ${VARCH} is NOT supported on ${UARCH}" && return 1
- ;;
- esac
- fi
- ##!! 4.2 is NO support on VARCH=x86_64 or VARCH=arch
- if [ "${VERSION}" = "4.2" ]; then
- if [ "${VARCH}" = "x86_64" -o "${VARCH}" = "arm" ]; then
- echo $"E: ${VERSION}_${VARCH} is NOT supported"
- return 1
- fi
- fi
- ## set base profile <version>_<arch>
- BASE_PROFILE=${VERSION}_${VARCH}
- ## check support ${BASE_PROFILE}
- if [ -z "$(/usr/sbin/vbootstrap | sed -e s/^Usage:.*// -e s/^E:.*// | grep -m 1 ${BASE_PROFILE})" ]; then
- echo $"E: ${BASE_PROFILE} is NOT supported"
- return 1
- fi
- ## check ${VERSION} equals VineSeed*, when with_dist_upgrade=1
- if [ $with_dist_upgrade -eq 1 ]; then
- if [ "${VERSION}" != "VineSeed" ]; then
- echo $"E: version ${VERSION} does not support --dist-upgrade option"
- return 1
- fi
- fi
- ## support i386 chroot on x86_64 below:
- [ "${UARCH}" = "x86_64" -a "${VARCH}" = "i386" ] && \
- with_ix86_on_x86_64=1
- ## check apt categories
- ## "main" category is unconditionally permited
- with_category_main=1
- for cat in $(echo ${CATEGORIES} | sed -e "s/,/ /"g); do
- case $cat in
- main)
- with_category_main=1
- ;;
- plus)
- with_category_plus=1
- ;;
- nonfree)
- with_category_nonfree=1
- ;;
- test)
- ## "test" category only exists in VineSeed
- [ "${VERSION}" = "VineSeed" ] || \
- echo $"E: No such category exists: $cat" && return 1
- with_category_test=1
- ;;
- proposed-updates)
- ##!! "proposed-updates" category does not exist in 4.2
- [ "${VERSION}" = "4.2" ] && \
- echo $"E: No such category exists: $cat" && return 1
- with_category_proposed_updates=1
- ;;
- security)
- ## "security" category does not exist in VineSeed
- [ "${VERSION}" = "VineSeed" ] && \
- echo $"E: No such category exists: $cat" && return 1
- with_category_security=1
- ;;
- *)
- echo $"E: No such category exists: $cat" && return 1
- ;;
- esac
- done
- ## check build target option ${TARGET}
- if [ ! -z "${TARGET}" ]; then
- RPM_TARGET_LIST="$(cat /usr/lib/rpm/rpmrc | grep arch_canon: | sed -e "s/arch_canon:[[:blank:]]*\(.*\):.*/\1/")"
- RPM_TARGET_LIST="${RPM_TARGET_LIST} noarch"
- if [ -z "$(echo ${RPM_TARGET_LIST} | grep ${TARGET})" ]; then
- echo $"E: rpm build target ${TARGET} is NOT supported"
- return 1
- fi
- fi
- ## set ${RPM_PKG_ARCH_LIST}
- RPM_PKG_ARCH_LIST=" \
- RPMS/i386 RPMS/i486 RPMS/i586 RPMS/i686 RPMS/x86_64 RPMS/ppc \
- RPMS/noarch \
- RPMS/armv3l RPMS/armv4l RPMS/armv4tl \
- RPMS/armv5tejl RPMS/armv5tel RPMS/armv6l RPMS/armv7l \
- SRPMS"
- [ -z "${TARGET}" ] || \
- RPM_PKG_ARCH_LIST="RPMS/${TARGET} ${RPM_PKG_ARCH_LIST}"
- fi
- ## set global variables
- BUILD_USER=vbuilder
- BUILD_DIR=/home/${BUILD_USER}/rpm
- if [ ${with_profile} -eq 1 ]; then
- BUILD_ROOT=${VBOOTSTRAP_DIR}/${PROFILE}
- UNIONFS_ROOT=${UNIONFS_DIR}/${PROFILE}
- else
- BUILD_ROOT=${VBOOTSTRAP_DIR}/${BASE_PROFILE}
- UNIONFS_ROOT=${UNIONFS_DIR}/${BASE_PROFILE}
- fi
- ARCHIVES_DIR=${BUILD_ROOT}/var/cache/apt/archives
- EXTERNAL_ARCHIVES_DIR=${CACHE_DIR}/${BASE_PROFILE}/apt/archives
- UNIONFS_WORK=${UNIONFS_DIR}/unionfs_work
- __chroot_sh="/usr/sbin/chroot ${BUILD_ROOT} /bin/sh -c -l"
- mkdir -p $VBOOTSTRAP_DIR
- return 0
- }
- setup-vbootstrap-rpm(){
- setup-vbootstrap || return 1
- ## check ${BUILD_ROOT}
- [ -d ${BUILD_ROOT} ] || Build
- ## setarch ix86 if ix86 chroot on x86_64 host
- [ $with_ix86_on_x86_64 -eq 1 ] && \
- __chroot_sh="/usr/sbin/chroot ${BUILD_ROOT} setarch ${VARCH} /bin/sh -c -l"
- DIST_RELEASE=$(cat ${BUILD_ROOT}/etc/vine-release | cut -f3 -d" " | cut -f1 -d.)
- if [ -f $RPM_PKG ]; then
- BASE_RPM_PKG=$(basename $RPM_PKG)
- cp -f $RPM_PKG $BUILD_ROOT${BUILD_DIR}
- else
- BASE_RPM_PKG=$RPM_PKG
- fi
- return 0
- }
- ## recover apt-get data on host/chroot
- apt-get-update(){
- case $1 in
- --host)
- echo -n $"apt-get update on host ... "
- apt-get -qq update > /dev/null 2>&1
- echo $"done."
- ;;
- --chroot)
- echo -n $"apt-get update on chroot ... "
- $__chroot_sh 'apt-get -qq update' > /dev/null 2>&1
- echo $"done."
- ;;
- *)
- echo apt-get-update: unknown option $1
- exit 1
- ;;
- esac
- }
- ## mount-chroot {|--umount} [file system|name]
- ## support file systems: /home /tmp /sys /proc /dev/shm /dev/pts /dev
- ## support names: vfs archives_dir
- ## NOTE: /tmp needs for applications which use X
- ## vfs is virtual file systems
- ## archives_dir uses to mount ${EXTERNAL_ARCHIVES_DIR} to ${ARCHIVES_DIR}
- ## unionfs_dir covers ${BUILD_ROOT} with unionfs
- mount-chroot(){
- if [ "$1" = "--umount" ]; then
- mount-chroot-umount $2 || return 1
- else
- mount-chroot-mount $1 || return 1
- fi
- return 0
- }
- ## mount-chroot-umount [file system|name]
- mount-chroot-umount(){
- local fs=$1
- case $fs in
- /home|/tmp|/sys|/proc|/dev/shm|/dev/pts|/dev)
- [ -d ${BUILD_ROOT}${fs} ] || return 1
- [ -z "$(mount | grep ${BUILD_ROOT}${fs})" ] || \
- umount ${BUILD_ROOT}${fs}
- if [ ! -z "$(mount | grep ${BUILD_ROOT}${fs})" ]; then
- echo $"Retry lazy unmount ${BUILD_ROOT}${fs} ... "
- umount -l ${BUILD_ROOT}${fs}
- echo $"done."
- fi
- ;;
- vfs)
- for dir in /sys /proc /dev/shm /dev/pts /dev; do
- mount-chroot-umount ${dir} || return 1
- done
- ;;
- archives_dir)
- [ -d ${ARCHIVES_DIR} ] || return 1
- [ -z "$(mount | grep ${ARCHIVES_DIR})" ] || \
- umount ${ARCHIVES_DIR}
- ;;
- unionfs_dir)
- [ -d ${BUILD_ROOT} ] || return 1
- [ -z "$(mount | grep ${BUILD_ROOT} | egrep '(unionfs|aufs|overlay)')" ] || \
- umount ${BUILD_ROOT}
- if [ ! -z "$(mount | grep ${BUILD_ROOT} | egrep '(unionfs|aufs|overlay)')" ]; then
- echo $"Retry lazy unmount ${BUILD_ROOT} ... "
- umount -l ${BUILD_ROOT}
- echo $"done."
- fi
- ;;
- *)
- echo mount-chroot-umount: unknown file system $fs
- exit 1
- ;;
- esac
- return 0
- }
- ## mount-chroot-mount [file system|name]
- mount-chroot-mount(){
- local fs=$1
- case $fs in
- /home)
- [ -d ${BUILD_ROOT}${fs} ] || mkdir -p ${BUILD_ROOT}${fs}
- [ -z "$(mount | grep ${BUILD_ROOT}${fs})" ] && \
- mount -o _netdev,rbind ${fs} ${BUILD_ROOT}${fs}
- ;;
- /tmp|/dev)
- [ -d ${BUILD_ROOT}${fs} ] || mkdir -p ${BUILD_ROOT}${fs}
- [ -z "$(mount | grep ${BUILD_ROOT}${fs})" ] && \
- mount --bind -o _netdev ${fs} ${BUILD_ROOT}${fs}
- ;;
- /sys)
- [ -d ${BUILD_ROOT}${fs} ] || mkdir -p ${BUILD_ROOT}${fs}
- [ -z "$(mount | grep ${BUILD_ROOT}${fs})" ] && \
- mount -o _netdev -t sysfs vbuildersysfs ${BUILD_ROOT}${fs}
- ;;
- /proc)
- [ -d ${BUILD_ROOT}${fs} ] || mkdir -p ${BUILD_ROOT}${fs}
- [ -z "$(mount | grep ${BUILD_ROOT}${fs})" ] && \
- mount -o _netdev -t proc vbuilderproc ${BUILD_ROOT}${fs}
- ;;
- /dev/shm)
- [ -d ${BUILD_ROOT}${fs} ] || mkdir -p ${BUILD_ROOT}${fs}
- [ -z "$(mount | grep ${BUILD_ROOT}${fs})" ] && \
- mount -o _netdev -t tmpfs vbuildertmpfs ${BUILD_ROOT}${fs}
- ;;
- /dev/pts)
- [ -d ${BUILD_ROOT}${fs} ] || mkdir -p ${BUILD_ROOT}${fs}
- [ -z "$(mount | grep ${BUILD_ROOT}${fs})" ] && \
- mount -o gid=5,mode=620,_netdev -t devpts vbuilderdevpts ${BUILD_ROOT}${fs}
- ;;
- vfs)
- for dir in /dev /dev/pts /dev/shm /proc /sys; do
- mount-chroot-mount ${dir} || return 1
- done
- ;;
- archives_dir)
- [ -d ${EXTERNAL_ARCHIVES_DIR} ] || mkdir -p ${EXTERNAL_ARCHIVES_DIR}
- [ -d ${ARCHIVES_DIR} ] || mkdir -p ${ARCHIVES_DIR}
- [ -z "$(mount | grep ${ARCHIVES_DIR})" ] && \
- mount --bind -o _netdev ${EXTERNAL_ARCHIVES_DIR} ${ARCHIVES_DIR}
- [ -d ${ARCHIVES_DIR}/partial ] || mkdir -p ${ARCHIVES_DIR}/partial
- ;;
- unionfs_dir)
- if [ $with_unionfs -eq 1 ]; then
- [ -d ${UNIONFS_ROOT} ] || mkdir -p ${UNIONFS_ROOT}
- if [ -d ${UNIONFS_WORK} ]; then
- #workdir needs emply
- rm -rf ${UNIONFS_WORK}; mkdir -p ${UNIONFS_WORK}
- else
- mkdir -p ${UNIONFS_WORK}
- fi
- /sbin/modprobe overlay >& /dev/null ||:
- /sbin/modprobe aufs >& /dev/null ||:
- #overlayfs
- if ( grep -q overlay /proc/filesystems ) ; then
- [ -z "$(mount | grep ${UNIONFS_ROOT})" ] && \
- mount -t overlay overlay -o lowerdir=${BUILD_ROOT},upperdir=${UNIONFS_ROOT},workdir=${UNIONFS_WORK} ${BUILD_ROOT}
- #aufs
- elif ( grep -q aufs /proc/filesystems ) ; then
- [ -z "$(mount | grep ${UNIONFS_ROOT})" ] && \
- mount -t aufs -o br=${UNIONFS_ROOT}=rw:${BUILD_ROOT}=ro aufs ${BUILD_ROOT}
- else
- #unionfs
- [ -z "$(mount | grep ${UNIONFS_ROOT})" ] && \
- mount -t unionfs -o dirs=${UNIONFS_ROOT}=rw:${BUILD_ROOT}=ro unionfs ${BUILD_ROOT}
- unionctl ${BUILD_ROOT} --list
- fi
- fi
- ;;
- *)
- echo mount-chroot-mount: unknown file system $fs
- exit 1
- ;;
- esac
- return 0
- }
- ## TODO: support spec-validator
- ## spec-validator [spec file]
- spec-validator(){
- echo
- return 0
- }
- ##############################################################################
- Clean(){
- setup-vbootstrap || return 1
- # mount-chroot --umount /home
- mount-chroot --umount /tmp
- mount-chroot --umount /dev/shm
- mount-chroot --umount /dev/pts
- mount-chroot --umount /proc
- mount-chroot --umount archives_dir
- mount-chroot --umount unionfs_dir
- apt-get-update --host
- ## We remark that we first remove /, and secondly remove /.
- ## If we directly remove /, we obtained some non-empty directories:
- ## /dev/.udev/rules.d.
- if [ $with_unionfs -eq 1 ]; then
- if [ -d ${UNIONFS_ROOT} ]; then
- echo -n $"Cleaning build root ${UNIONFS_ROOT} via unionfs ... "
- rm -rf ${UNIONFS_ROOT} 2>/dev/null
- rm -rf ${UNIONFS_ROOT}
- echo $"done."
- fi
- else
- if [ -d ${BUILD_ROOT} ]; then
- echo -n $"Cleaning build root ${BUILD_ROOT} ... "
- rm -rf ${BUILD_ROOT} 2>/dev/null
- rm -rf ${BUILD_ROOT}
- echo $"done."
- fi
- fi
- echo $"Cleanup a build farm for ${BUILD_ROOT} done."
- return 0
- }
- Build(){
- setup-vbootstrap || return 1
- if [ $with_dist_upgrade -eq 1 ]; then
- ## make bootstrap of ${STABLE_VERSION}
- /usr/sbin/vbootstrap \
- $(echo ${BASE_PROFILE} | sed -e "s/VineSeed/${STABLE_VERSION}/") \
- ${VBOOTSTRAP_FETCH_URL} ${BUILD_ROOT} 2>&1 | \
- egrep -v -e '^W: Duplicate sources.list entry' \
- -e '^W: .*apt-get update'
- ## aim apt-line to VineSeed
- sed -i "s/apt ${STABLE_VERSION}/apt VineSeed/g" \
- ${BUILD_ROOT}/etc/apt/sources.list.d/main.list
- else
- /usr/sbin/vbootstrap \
- ${BASE_PROFILE} ${VBOOTSTRAP_FETCH_URL} ${BUILD_ROOT} 2>&1 | \
- egrep -v -e '^W: Duplicate sources.list entry' \
- -e '^W: .*apt-get update'
- fi
- mount-chroot /proc
- mount-chroot archives_dir
- mount-chroot /dev/pts
- mount-chroot /dev/shm
- # mount-chroot /tmp
- # mount-chroot /home
- local __replace_fetch_url="sed -i -e s|@@VBUILDER_VBOOTSTRAP_FETCH_URL@@|${VBOOTSTRAP_FETCH_URL}|g"
- case ${VERSION} in
- 4.2)
- ##!! 4.2 has no apt-sourceslist-{plus,nonfree,proposed-updates} packages
- $__replace_fetch_url ${BUILD_ROOT}/etc/apt/sources.list
- for i in main plus nonfree; do
- [ ! -z "$(echo ${CATEGORIES} | grep ${i})" ] && continue
- sed -i -e "s, ${i},,g" ${BUILD_ROOT}/etc/apt/sources.list
- done
- $__chroot_sh 'apt-get -qq update && apt-get -qq -y dist-upgrade'
- # [ $with_category_security -eq 1 ] && \
- # echo
- ;;
- 5.2|6|@@VBUILDER_STABLE_VERSION@@)
- $__replace_fetch_url ${BUILD_ROOT}/etc/apt/sources.list.d/main.list
- $__chroot_sh 'apt-get -qq update && apt-get -qq -y dist-upgrade'
- [ $with_category_plus -eq 1 ] && \
- $__chroot_sh 'apt-get -qq update && apt-get -qq -y install apt-sourceslist-plus' && \
- $__replace_fetch_url ${BUILD_ROOT}/etc/apt/sources.list.d/plus.list
- [ $with_category_nonfree -eq 1 ] && \
- $__chroot_sh 'apt-get -qq update && apt-get -qq -y install apt-sourceslist-nonfree' && \
- $__replace_fetch_url ${BUILD_ROOT}/etc/apt/sources.list.d/nonfree.list
- [ $with_category_proposed_updates -eq 1 ] && \
- $__chroot_sh 'apt-get -qq update && apt-get -qq -y install apt-sourceslist-proposed-updates' && \
- $__replace_fetch_url ${BUILD_ROOT}/etc/apt/sources.list.d/proposed-updates.list
- # [ $with_category_security -eq 1 ] && \
- # echo
- ;;
- VineSeed)
- $__replace_fetch_url ${BUILD_ROOT}/etc/apt/sources.list.d/main.list
- $__chroot_sh 'apt-get -qq update && apt-get -qq -y dist-upgrade'
- [ $with_category_plus -eq 1 ] && \
- $__chroot_sh 'apt-get -qq update && apt-get -qq -y install apt-sourceslist-plus' && \
- $__replace_fetch_url ${BUILD_ROOT}/etc/apt/sources.list.d/plus.list
- [ $with_category_nonfree -eq 1 ] && \
- $__chroot_sh 'apt-get -qq update && apt-get -qq -y install apt-sourceslist-nonfree' && \
- $__replace_fetch_url ${BUILD_ROOT}/etc/apt/sources.list.d/nonfree.list
- [ $with_category_test -eq 1 ] && \
- $__chroot_sh 'apt-get -qq update && apt-get -qq -y install apt-sourceslist-test' && \
- $__replace_fetch_url ${BUILD_ROOT}/etc/apt/sources.list.d/test.list
- ;;
- esac
- [ $with_dist_upgrade -eq 1 ] && \
- $__chroot_sh 'apt-get -qq update && apt-get -qq -y dist-upgrade'
- [ $with_build_essential -eq 1 ] && \
- $__chroot_sh 'apt-get -qq -y install build-essential'
- $__chroot_sh 'apt-get -qq -y install etcskel shadow-utils MAKEDEV'
- $__chroot_sh 'cd /dev && /sbin/MAKEDEV console'
- $__chroot_sh 'cd /dev && /sbin/MAKEDEV ptmx'
- $__chroot_sh 'cd /dev && /sbin/MAKEDEV null'
- $__chroot_sh 'cd /dev && /sbin/MAKEDEV zero'
- $__chroot_sh 'cd /dev && /sbin/MAKEDEV random'
- $__chroot_sh 'cd /dev && /sbin/MAKEDEV urandom'
- $__chroot_sh 'cd /dev && mkdir -p shm && chmod 777 shm'
- $__chroot_sh 'cd /dev && mkdir -p pts && chmod 755 pts'
- $__chroot_sh '/usr/sbin/pwconv'
- $__chroot_sh "/usr/sbin/useradd ${BUILD_USER}"
- ##!! for rpm-4.8.0 or higher
- ##!! (See http://trac.vinelinux.org/wiki/Vine6/AboutUpdateToolchain)
- if [ "${VERSION}" = "VineSeed" ]; then
- $__chroot_sh "sed -i -e 's/^%_topdir/#%_topdir/' /home/${BUILD_USER}/.rpmmacros"
- fi
- ## set local repositories (profile only)
- if [ ${with_profile} -eq 1 ]; then
- if [ ! -z "${LOCAL_REPOS}" ]; then
- cat >${BUILD_ROOT}/etc/apt/sources.list.d/local.list<<EOF
- ${LOCAL_REPOS}
- EOF
- $__chroot_sh "apt-get update"
- fi
- ## additional base packages
- [ ! -z "${ADD_BASE_PKGS}" ] && \
- $__chroot_sh "apt-get -y install ${ADD_BASE_PKGS}"
- fi
- # mount-chroot --umount /home
- # mount-chroot --umount /tmp
- mount-chroot --umount /dev/shm
- mount-chroot --umount /dev/pts
- mount-chroot --umount archives_dir
- mount-chroot --umount /proc
- apt-get-update --host
- echo $"Making a build farm for ${BUILD_ROOT} done."
- return 0
- }
- RPM_Remove(){
- setup-vbootstrap-rpm || return 1
- mount-chroot unionfs_dir
- mount-chroot archives_dir
- mount-chroot /proc
- mount-chroot /dev/pts
- mount-chroot /dev/shm
- # apt-get-update --chroot
- [ -f $RPM_PKG ] && \
- echo $"E: $RPM_PKG is not a package name" && return 1
- $__chroot_sh "apt-get -y remove $BASE_RPM_PKG"
- mount-chroot --umount /dev/shm
- mount-chroot --umount /dev/pts
- mount-chroot --umount /proc
- mount-chroot --umount archives_dir
- mount-chroot --umount unionfs_dir
- # apt-get-update --host
- return 0
- }
- RPM_Install(){
- setup-vbootstrap-rpm || return 1
- mount-chroot unionfs_dir
- mount-chroot archives_dir
- mount-chroot /proc
- mount-chroot /dev/pts
- mount-chroot /dev/shm
- apt-get-update --chroot
- [ $with_category_nonfree -eq 1 ] && \
- [ ! -z "$(echo $BASE_RPM_PKG | grep -e 'self-build-' -e 'install-assist-')" ] && \
- $__chroot_sh 'rpm -q --quiet self-build-setup || apt-get -qq -y install self-build-setup'
- $__chroot_sh "cd ${BUILD_DIR} && apt-get -y install $BASE_RPM_PKG"
- mount-chroot --umount /dev/shm
- mount-chroot --umount /dev/pts
- mount-chroot --umount /proc
- mount-chroot --umount archives_dir
- mount-chroot --umount unionfs_dir
- apt-get-update --host
- return 0
- }
- RPM_Build(){
- [ ! -f ${RPM_PKG} ] && \
- echo $"E: No such file found: ${RPM_PKG}" && return 1
- ## check the extension of given $RPM_PKG
- local RPM_PKG_EXT=${RPM_PKG##*.}
- case ${RPM_PKG_EXT} in
- spec)
- ## In this case,
- ## the file ${RPM_PKG} is a spec file!
- # spec-validator ${RPM_PKG} || return 1
- # return 1
- ## We assign the variable ${RPM_PKG}
- ## the src.rpm generated by the spec file ${RPM_PKG}.
- RPM_PKG=$(rpm -E "%{_srcrpmdir}")/$(rpm -q --qf "%{name}-%{version}-%{release}\n" --specfile ${RPM_PKG} | head -n 1).src.rpm
- ;;
- rpm)
- RPM_PKG_EXT=$(echo ${RPM_PKG} | sed -e "s|.*\.\(src\.rpm\)$|\1|")
- [ "${RPM_PKG_EXT}" != "src.rpm" ] && \
- echo $"E: $RPM_PKG is NOT a source RPM package" && return 1
- ;;
- *)
- echo $"The action build-rpm cannot work such extension: ${RPM_PKG_EXT}"
- return 1
- ;;
- esac
- setup-vbootstrap-rpm || return 1
- mount-chroot unionfs_dir
- mount-chroot archives_dir
- mount-chroot /proc
- mount-chroot /dev/pts
- mount-chroot /dev/shm
- apt-get-update --chroot
-
- [ ! -f ${RPM_PKG} ] && \
- echo $"E: No such file found: ${RPM_PKG}" && return 1
- RPM_PKG_USER=$(stat -c %U $RPM_PKG)
- RPM_PKG_GROUP=$(stat -c %G $RPM_PKG)
- [ ! -z "${SUDO_UID}" ] && RPM_PKG_USER=${SUDO_UID}
- [ ! -z "${SUDO_GID}" ] && RPM_PKG_GROUP=${SUDO_GID}
- local __install="install -p -v -o ${RPM_PKG_USER} -g ${RPM_PKG_GROUP}"
- ## make src.rpm for $VERSION
- $__chroot_sh "cd ${BUILD_DIR} && su ${BUILD_USER} -c 'rpm -ivh $BASE_RPM_PKG'"
- $__chroot_sh "cd ${BUILD_DIR} && su ${BUILD_USER} -c 'rpmbuild -bs --nodeps --clean --rmsource --rmspec $RPM_OPTS ${BUILD_DIR}/SPECS/*.spec'"
- ## change ${DIST_RELEASE}
- BASE_RPM_PKG=$(echo $BASE_RPM_PKG | sed -e "s/vl[0-9]*\([A-Za-z]*[0-9A-Za-z]*\)\./vl${DIST_RELEASE}\1\./")
- ## rebuild $BASE_RPM_PKG on ${DIST_RELEASE}
- $__chroot_sh "cd ${BUILD_DIR}/SRPMS && apt-get -o APT::Install::Virtual=true -y build-dep $BASE_RPM_PKG"
- $__chroot_sh "cd ${BUILD_DIR}/SRPMS && su ${BUILD_USER} -c 'rpmbuild --rebuild $RPM_OPTS $BASE_RPM_PKG'"
- BUILT_RPMS_LIST=$(find $BUILD_ROOT${BUILD_DIR}/RPMS -type f -regex '.*\.rpm' | sed -e s,${BUILD_ROOT},,g -e 's|.*\/compat32-.*||g' -e 's|.*\/.*\.src\.rpm||g' -e 's/$/ \\/g')
- [ $with_category_nonfree -eq 1 ] && \
- [ ! -z "$(echo $BUILT_RPMS_LIST | grep -e 'self-build-' -e 'install-assist-')" ] && \
- $__chroot_sh 'rpm -q --quiet self-build-setup || apt-get -qq -y install self-build-setup'
- [ $with_no_install -eq 0 ] && \
- $__chroot_sh "cd ${BUILD_DIR} && apt-get -y install $BUILT_RPMS_LIST"
- ## copy built rpms to ${HOME}/rpm/ for each archtectures
- echo $"Copying built rpms to ${BUILT_RPMS_DIR} for each archtectures ... "
- for i in $RPM_PKG_ARCH_LIST; do
- [ -d $BUILD_ROOT${BUILD_DIR}/${i} ] || continue
- if [ ! -d ${BUILT_RPMS_DIR}/${VERSION}/${i} ]; then
- $__install -d ${BUILT_RPMS_DIR}/${VERSION}/${i}/
- chown -R ${RPM_PKG_USER}:${RPM_PKG_GROUP} ${BUILT_RPMS_DIR}
- fi
- find $BUILD_ROOT${BUILD_DIR}/${i} -type f -regex '.*\.rpm' \
- -exec $__install -m0644 {} ${BUILT_RPMS_DIR}/${VERSION}/${i}/ \;
- done
- mount-chroot --umount /dev/shm
- mount-chroot --umount /dev/pts
- mount-chroot --umount /proc
- mount-chroot --umount archives_dir
- mount-chroot --umount unionfs_dir
- apt-get-update --host
- echo $"done."
- return 0
- }
- RPM_Sign(){
- [ $with_sign -eq 1 ] || return 1
- setup-vbootstrap || return 1
- [ -d ${BUILD_ROOT} ] || Build
- mount-chroot unionfs_dir
- echo $"Signing built rpms using ${RPM_SIGN_USER}'s key: "
- su $RPM_SIGN_USER -c "rpmsign --addsign $(for i in $RPM_PKG_ARCH_LIST; do find $BUILD_ROOT${BUILD_DIR}/${i} -type f -regex '.*\.rpm' 2>/dev/null; done | sed -e s,$BUILD_ROOT${BUILD_DIR},${BUILT_RPMS_DIR}/${VERSION},g -e 's/$/ \\/g')"
- mount-chroot --umount unionfs_dir
- return 0
- }
- Login_Chroot(){
- [ $with_login -eq 1 ] || return 1
- setup-vbootstrap || return 1
- __chroot="/usr/sbin/chroot ${BUILD_ROOT}"
- ## setarch ix86 if ix86 chroot on x86_64 host
- [ $with_ix86_on_x86_64 -eq 1 ] && \
- __chroot="/usr/sbin/chroot ${BUILD_ROOT} setarch ${VARCH}"
- mount-chroot unionfs_dir
- mount-chroot archives_dir
- mount-chroot /proc
- mount-chroot /dev/pts
- mount-chroot /dev/shm
- mount-chroot /tmp
- # mount-chroot /home
- # apt-get-update --chroot
- ## copy host's configurations of /etc
- #passwd shadow group gshadow
- for i in resolv.conf hosts; do
- cp -pf /etc/${i} ${BUILD_ROOT}/etc
- done
- cp -Ppf /etc/localtime ${BUILD_ROOT}/etc
- $__chroot /bin/bash
- # mount-chroot --umount /home
- mount-chroot --umount /tmp
- mount-chroot --umount /dev/shm
- mount-chroot --umount /dev/pts
- mount-chroot --umount /proc
- mount-chroot --umount archives_dir
- mount-chroot --umount unionfs_dir
- # apt-get-update --host
- return 0
- }
- ##############################################################################
- initialize-variables || exit 1
- check-parameter $* || exit 1
- setup-vbuilder || exit 1
- while [ $# -gt 0 ]; do
- tmpARG=$1
- case $tmpARG in
- --profile)
- shift
- ;;
- --version|--arch|--category|--fetch-url|--target|--rpmbuild-define|--rpmbuild-with|--rpmbuild-without|--bootstrap-dir|--unionfs-dir|--cache-dir|--built-rpms-dir)
- shift
- ;;
- --dist-upgrade|--unionfs|--with-compat32|--sign|--no-install|--login|--no-build-essential|--debug)
- ;;
- --build-rpm|build-rpm|--install-rpm|install-rpm|--remove-rpm|remove-rpm)
- shift
- ;;
- --build|build|--clean|clean)
- ;;
- *)
- echo unknown option $1
- exit 1
- ;;
- esac
- case $tmpARG in
- --profile)
- ;;
- --version)
- VERSION=$1
- ;;
- --arch)
- VARCH=$1
- ;;
- --category)
- CATEGORIES=$1
- ;;
- --fetch-url)
- VBOOTSTRAP_FETCH_URL=$1
- ;;
- --dist-upgrade)
- with_dist_upgrade=1
- ;;
- --unionfs)
- with_unionfs=1
- ;;
- --target)
- TARGET=$1
- RPM_OPTS="${RPM_OPTS} --target $TARGET"
- ;;
- --with-compat32)
- RPM_OPTS="${RPM_OPTS} --with compat32"
- ;;
- --rpmbuild-define)
- RPM_OPTS="${RPM_OPTS} --define $1"
- ;;
- --rpmbuild-with)
- RPM_OPTS="${RPM_OPTS} --with $1"
- ;;
- --rpmbuild-without)
- RPM_OPTS="${RPM_OPTS} --without $1"
- ;;
- --sign)
- with_sign=1
- ;;
- --no-install)
- with_no_install=1
- ;;
- --no-build-essential)
- with_build_essential=0
- ;;
- --login)
- with_login=1
- ;;
- --bootstrap-dir)
- VBOOTSTRAP_DIR=$1
- ;;
- --unionfs-dir)
- UNIONFS_DIR=$1
- ;;
- --cache-dir)
- CACHE_DIR=$1
- ;;
- --built-rpms-dir)
- BUILT_RPMS_DIR=$1
- ;;
- --debug)
- with_debug=1
- ;;
- --build-rpm|build-rpm)
- RPM_PKG=$1
- RPM_Build || exit 1
- ;;
- --install-rpm|install-rpm)
- RPM_PKG=$1
- RPM_Install || exit 1
- ;;
- --remove-rpm|remove-rpm)
- RPM_PKG=$1
- RPM_Remove || exit 1
- ;;
- --build|build)
- Build || exit 1
- ;;
- --clean|clean)
- Clean || exit 1
- ;;
- esac
- shift
- done
- RPM_Sign ||:
- Login_Chroot ||:
- exit
|